#!/usr/bin/python
#coding=UTF-8
#dinkpack.py
# Copyright © 2013 Tristan Norton <trisn@exemail.com.au>
# This work is free. You can redistribute it and/or modify it under the
# terms of the Do What The Fuck You Want To Public License, Version 2,
# as published by Sam Hocevar. See the COPYING file for more details.

 #I will probably end up rewriting this shit at some point

import easygui as eg
from sys import exit, argv
import os, shutil, subprocess, glob
import Image
import argparse

def checkdinkdata(datapath):
	"""Looks at a provided path and sort-of determines whether or not it is Dink Smallwood data"""
	if os.path.exists(os.path.join(datapath,"STORY")):
		print "Found the STORY dir suggesting that this is a valid DMOD!"
		return True
	else:
		print "Could not find the story dir meaning that this is probably not a valid Dink data folder"
		return False
	
def cmdline():
	"""Runs the command line utility packager"""
	print "The command line stuff doesn't work yet, unfortunately. Install easygui and Pillow with pip to get the gooey working"
	
def checkdel(path):
	"""Checks a given path to see if it exists and then deletes it if it does"""
	#This sort of thing already probably exists in the standard library somewhere
	if os.path.exists(path):
		shutil.rmtree(path)
		return True
	else:
		print "Dir %s couldn't be found! Therefore nothing to delete!" % path
		return False

def checkengine():
	"""Checks for a dir called engine containing freedink.exe that is required to run the DMOD"""
	if os.path.exists("engine/freedink.exe"):
		return True
	else:
		return False

def compress(name):
	"""Compresses a DMOD to a standalone 7z file or optionally uses the inbuilt compressor"""
	if os.path.exists("7za.exe"):
		subprocess.call("7za.exe a -sfx " + '"' + name + '"' + ' "' + name + '"', shell=True)
	else:
		shutil.make_archive(name,'zip',name)

def trimdata(path,dinkdata=False):
	"""Takes a Dink data collection and performs a few operations to make files smaller or whatever"""
	ordir = os.getcwd()
	if dinkdata:
		try:
		#Remove the map and hardfiles
			os.remove(path + "DINK.DAT")
			print "Removed dink.dat"
			os.remove(path + "MAP.DAT")
			print "Deleted map.dat"
			os.remove(path + "HARD.DAT")
			print "Deleted hard.dat"			
		except:
			print "The map files probably have already been deleted"
			
	#Converts the tiles to JPG format to save a considerable amount of file space
	os.chdir(path + "/tiles")
	for root, dirs, files in os.walk(os.getcwd()):
		for image in files:
			tileset = Image.open(image)
			if tileset.format == "BMP":
				new = tileset.convert("RGB")
				print "Converting file named %s" % image
				del tileset
				new.save(image,"JPEG",quality=50)
			else:
				print "This file %s may have already been converted or it is not compatible" % image
	#I think this stops it fucking things up
	os.chdir(ordir)




					
def gui():
	while True:
		tit = "Crap Dink Standalone Packager for Windows"
		
		if checkengine():
			print "Necessary exe file found, continuing"
		else:
			eg.msgbox("Could not find folder named 'engine' containing freedink.exe. Make a new folder called 'engine' and put freedink.exe into it",tit)
			exit(2)
		
		if not os.path.exists("dink"):
			eg.msgbox("Hello and welcome to the Dink DMOD Packager Programme. First of all we need to copy your original Dink data collection folder. This should only need to be done once. If you want to re-copy your Dink data sometime in the future, delete the folder named 'dink' in the same location as this program, and run this again.",tit)
			dinkpath = eg.diropenbox(title="Select your Dink data folder (contains STORY, GRAPHICS, TILES)",default="C:\Program Files (x86)\Dink Smallwood\Dink")
			if checkdinkdata(dinkpath):
				print "This appears to be a Dink Data folder, so let's copy it for use (may take a little while)"
				shutil.copytree(dinkpath,"dink")
			else:
				eg.msgbox("This does not appear to be a valid Dink data collection. Please make sure you have chosen the right path, and try again",tit)
				gui()
		
		#Delete the previously used DMOD dir if there is one
		checkdel("dmod")
		
		eg.msgbox("Please select the path of the DMOD you would like to package. A self-extracting 7z file will probably be created if everything goes well",tit)
		dmoddir = eg.diropenbox(title="Select DMOD you would like to package")
		if checkdinkdata(dmoddir):
			print "This appears to be a DMOD, let's copy it"
			shutil.copytree(dmoddir,"dmod")
		else:
			eg.msgbox("This does not appear to be a valid DMOD! Time to quit!",tit)
			exit(1)
		
		dmodname = eg.enterbox(default="Millderrr 3",msg="Please enter the name of the game you are packaging",title="Your DMOD Title")
		#Crappy checking stuff
		checkdel(dmodname)
		
		os.mkdir(dmodname)
		shutil.move("dmod",dmodname + "/dmod")
		shutil.copytree("engine",dmodname + "/engine")
		shutil.copytree("dink",dmodname + "/dink")
		shutil.copyfile("Play.bat",dmodname + "/Play.bat")
		print "Hopefully it will compress it now"
		trimdata(dmodname + "/dink",dinkdata=True)
		trimdata(dmodname + "/dmod")
		compress(dmodname)
		shutil.rmtree(dmodname)
		#Hopefully one of these will quit the program
		break
		sys.exit(0)
		exit(0)

if __name__ == "__main__":
	#Make it so that it runs the gooey if there are no arguments.
	if (len(argv) > 1):
		cmdline()
	else:
		gui()